function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }
function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }
function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }
/**
 * @copyright 2020 Tridium, Inc. All Rights Reserved.
 * @author James Johnson
 */

/** @jsx spandrel.jsx */

/**
 * API Status: **Private**
 * @module nmodule/vykonPro/rc/EnhancedBoundLabel
 */
define(['baja!', 'bajaux/spandrel', 'bajaux/Widget', 'nmodule/bajaui/rc/baja/Border', 'nmodule/vykonPro/rc/EnhancedLabel', 'baja!gx:Insets,gx:Brush,gx:Color,gx:Pen,kitPx:MouseOverEffect', 'css!nmodule/kitPx/rc/kitPx', 'css!nmodule/vykonPro/rc/vykonPro'], function (baja, spandrel, Widget, Border, EnhancedLabel) {
  'use strict';

  var widgetDefaults = function widgetDefaults() {
    return {
      properties: {
        border: Border.make('1 none black'),
        rootCssClass: 'ux-EnhancedBoundLabel',
        padding: baja.$('gx:Insets', 0),
        mouseOver: baja.$('kitPx:MouseOverEffect', 'none'),
        mouseOverBgnd: baja.$('gx:Brush', 'blue'),
        mouseOverFgnd: baja.$('gx:Brush', 'white'),
        mouseOverOutline: baja.$('gx:Brush', 'red'),
        mouseOverPen: baja.$('gx:Pen', '2')
      }
    };
  };
  var counter = 0;
  /**
  * @class
  * @alias module:nmodule/vykonPro/rc/EnhancedBoundLabel
  * @extends module:nmodule/vykonPro/rc/EnhancedLabel
  */
  return /*#__PURE__*/function (_spandrel) {
    _inherits(EnhancedBoundLabel, _spandrel);
    var _super = _createSuper(EnhancedBoundLabel);
    function EnhancedBoundLabel(params) {
      _classCallCheck(this, EnhancedBoundLabel);
      return _super.call(this, {
        params: params,
        defaults: widgetDefaults()
      });
    }
    return _createClass(EnhancedBoundLabel);
  }(spandrel(function (model, _ref) {
    var properties = _ref.properties,
      rootElement = _ref.rootElement;
    var border = properties.border,
      padding = properties.padding;
    var id = 'EnhancedBoundLabel' + ++counter;
    rootElement.id = id;

    //apply the padding as a margin on the Label-col, this allows the text to be in the correct spot
    // when their isn't enough space for the padding.
    properties.margin = padding;
    return spandrel.jsx("span", {
      className: "-v-EnhancedBoundLabel-col"
    }, spandrel.jsx(EnhancedLabel, {
      tagName: "span",
      properties: properties,
      value: model
    }), spandrel.jsx("div", {
      className: "-v-EnhancedBoundLabel-border",
      $init: function $init(el) {
        return border.applyToElement(el);
      }
    }), spandrel.jsx("style", null, makeStyle(id, properties)));
  }, {
    "extends": EnhancedLabel
  }));
  function makeStyle(id, properties) {
    var mouseOver = properties.mouseOver,
      mouseOverBgnd = properties.mouseOverBgnd,
      mouseOverFgnd = properties.mouseOverFgnd,
      mouseOverOutline = properties.mouseOverOutline,
      mouseOverPen = properties.mouseOverPen;
    // different css based on mouseOver...
    if (mouseOver.getTag() === "highlight") {
      return "\n        #".concat(id, ":hover .ux-Label, #").concat(id, ":hover .-t-Label-text {\n      background-color: ").concat(mouseOverBgnd.toString(), " !important; color: ").concat(mouseOverFgnd.toString(), " !important;\n      }\n      ");
    } else if (mouseOver.getTag() === "outline") {
      var penStyle = mouseOverPen.toString();
      var borderStyle = 'solid !important;';
      if (penStyle.indexOf('dash(2,2)') > -1) {
        // dotted pen
        borderStyle = 'dotted !important;';
      } else if (penStyle.indexOf('dash(8,2)') > -1) {
        // dashed pen
        borderStyle = 'dashed !important;';
      }
      ;
      return "\n        #".concat(id, " .-v-EnhancedBoundLabel-border:hover { \n      border-color: ").concat(mouseOverOutline.toString(), " !important; \n      border-style: ") + borderStyle + "border-width: ".concat(mouseOverPen.getWidth(), "px !important;\n      }\n      ");
    }
  }
});
