function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }
function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }
function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function _get() { if (typeof Reflect !== "undefined" && Reflect.get) { _get = Reflect.get.bind(); } else { _get = function _get(target, property, receiver) { var base = _superPropBase(target, property); if (!base) return; var desc = Object.getOwnPropertyDescriptor(base, property); if (desc.get) { return desc.get.call(arguments.length < 3 ? target : receiver); } return desc.value; }; } return _get.apply(this, arguments); }
function _superPropBase(object, property) { while (!Object.prototype.hasOwnProperty.call(object, property)) { object = _getPrototypeOf(object); if (object === null) break; } return object; }
function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }
function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }
function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }
/**
 * Copyright 2020 Tridium, Inc. All Rights Reserved.
 * @author James Johnson
 */

/**
 * API Status: **Private**
 * @module nmodule/vykonPro/rc/binding/EnhancedBoundLabelBinding
 */
define(['baja!', 'baja!kitPx:StatusEffect', 'nmodule/vykonPro/rc/binding/EnhancedValueBinding', 'nmodule/gx/rc/baja/Brush', 'nmodule/webEditors/rc/wb/mgr/componentStatusUtils'], function (baja, types, EnhancedValueBinding, Brush, componentStatusUtils) {
  'use strict';

  var getBackground = componentStatusUtils.getBackground,
    getForeground = componentStatusUtils.getForeground;

  /**
   * BajaScript implementation of `vykonPro:EnhancedBoundLabelBinding`.
   * @class
   * @alias module:nmodule/vykonPro/rc/binding/EnhancedBoundLabelBinding
   * @extends module:nmodule/vykonPro/rc/binding/EnhancedValueBinding
   */
  return /*#__PURE__*/function (_EnhancedValueBinding) {
    _inherits(EnhancedBoundLabelBinding, _EnhancedValueBinding);
    var _super = _createSuper(EnhancedBoundLabelBinding);
    function EnhancedBoundLabelBinding() {
      _classCallCheck(this, EnhancedBoundLabelBinding);
      return _super.apply(this, arguments);
    }
    _createClass(EnhancedBoundLabelBinding, [{
      key: "provide",
      value:
      /**
       * If the bound point is an instance of `baja:IStatus` and effects enabled,
       * provides the following overrides:
       *
       * - `blink`: is the point in unackedAlarm status?
       * - `foreground`: the foreground color for the status configured in the lexicon
       * - `background`: the background color for the status configured in the lexicon
       * - `border`: special border behavior for `baja:StatusBoolean`s
       *
       * @param {string} name
       * @param {object} [cx]
       */
      function provide(name, cx) {
        var ordTarget = this.isBound() && this.getOrdTarget();
        var obj = ordTarget && ordTarget.getObject();
        var statusEffect = this.get('statusEffect').getTag();
        if (!ordTarget || !baja.hasType(obj, 'baja:IStatus') || statusEffect === 'none') {
          return _get(_getPrototypeOf(EnhancedBoundLabelBinding.prototype), "provide", this).apply(this, arguments);
        }
        var status = baja.Status.getStatusFromIStatus(obj);
        switch (name) {
          case 'blink':
            if (status.isUnackedAlarm() && statusEffect === 'colorAndBlink') {
              return true;
            }
            break;
          case 'foreground':
            var fg = getForeground(status);
            if (fg) {
              return Brush.make(fg);
            }
            break;
          case 'background':
            var bg = getBackground(status);
            if (bg) {
              return Brush.make(bg);
            }
            break;
          case 'border':
            if (!baja.hasType(obj, 'baja:StatusBoolean')) {
              break;
            }
            var converter = this.get(name);
            if (baja.hasType(converter, 'converters:FixedSimple')) {
              return converter.get('value');
            }
            if (baja.hasType(converter, 'converters:PassThrough')) {
              return converter.convert(obj, this.getWidget().properties().getValue(name));
            }
            if (baja.hasType(converter, 'converters:INumericToSimple')) {
              var map = converter.get('map');
              var num = obj.get('value') ? getHighest(map) : getLowest(map);
              return map.get(num);
            }
            break;
        }
        return _get(_getPrototypeOf(EnhancedBoundLabelBinding.prototype), "provide", this).apply(this, arguments);
      }
    }]);
    return EnhancedBoundLabelBinding;
  }(EnhancedValueBinding);
  function getHighest(map) {
    return Math.max.apply(Math, _toConsumableArray(map.getMaximums()));
  }
  function getLowest(map) {
    return Math.min.apply(Math, _toConsumableArray(map.getMinimums()));
  }
});
